      program diff

!        calculate forward, central, and extrapolated differentiation
!        of a given function

      implicit none

!      double precision :: fcos, h, hd2, hd4, x, xmin, xmax, xstep
!      double precision :: result(3)

      real :: fcos, h, hd2, hd4, x, xmin, xmax, xstep
      real :: result(3)
      integer :: kwrite

      data kwrite/6/

      open(kwrite, File = 'diff.out', Status = 'Unknown')

      h = 1.d-5

      hd2 = h*0.5d0
      hd4 = h*0.25d0

      xmin  = 0.0d0
      xmax  = 7.0d0
      xstep = 0.01d0

      do x = xmin, xmax, xstep

!        forward
      result(1) = (fcos(x+h) - fcos(x))/h
!        central
      result(2) = (fcos(x+hd2) - fcos(x-hd2))/h
!        extrapolated
      result(3) = (8.d0 *(fcos(x+hd4)-fcos(x-hd4)) - &
     &                 (fcos(x+hd2)-fcos(x-hd2)))/(3.d0*h)

      write (kwrite,10000) x, result(1), result(2), result(3)
      end do

10000 format(F5.3,4x, F11.8,4x, F11.8,4x, F11.8) 

      close(kwrite)

      stop 'data saved in diff.out'
      
      end program diff
!--------------------------------------------------------------------------

!      double precision function fcos(x)
      function fcos(x)

      implicit none

!      double precision ::  x, fcos
      real ::  x, fcos

      fcos = cos(x)

      return
      end
!--------------------------------------------------------------------------

!      double precision function fexp(x)
      function fexp(x)

      implicit none

!      double precision ::  x, fexp
      real ::  x, fexp

      fexp = exp(x)

      return
      end
!--------------------------------------------------------------------------

!      double precision function fsq(x)
      function fsq(x)

      implicit none

!      double precision ::  x, fsq
      real ::  x, fsq

      fsq = sqrt(x)

      return
      end
